;------------------------------------------------------------------------------------------------
;  Net2BBS Telnet Server
;  Version 1.0.3<Omega>
;  Written by Mike Ehlert, PC Micro Systems, Inc. 
;  http://pcmicro.com/netfoss
;  Released as Public Domain, Open Source Code.
;  Read Net2BBS.txt for license details.
; 
;  Compile in MASM32, using "Console Assemble and Link"
;  or link using Polink.exe for optimum file size.
;------------------------------------------------------------------------------------------------
.586
.model flat,stdcall

option casemap:none
   include \masm32\include\windows.inc	; Windows
   include \masm32\include\user32.inc	; User
   include \masm32\include\kernel32.inc	; Kernel
   include \masm32\include\ws2_32.inc	; Winsock 2.0
   include \masm32\include\winmm.inc	; MultiMedia play functions
   include \masm32\include\masm32.inc	; MASM32
   include \masm32\macros\macros.asm	; MASM32 Macros
   includelib \masm32\lib\user32.lib	; User
   includelib \masm32\lib\kernel32.lib	; Kernel
   includelib \masm32\lib\ws2_32.lib	; WinSock 2.0
  ;includelib \masm32\lib\wsock32.lib	; WinSock 2.0
   includelib \masm32\lib\winmm.lib	; MultiMedia play functions
   includelib \masm32\lib\masm32.lib	; MASM32
   includelib \masm32\lib\msvcrt.lib	; C library (only used for getkey)

   StartServer     proto
   AcceptThread    proto :DWORD
   SpawnNodeThread proto :DWORD
   Shell           proto :DWORD,:DWORD
   SetTextColor    proto :DWORD,:DWORD
   GetAppPath      proto :DWORD
   Replace         proto :DWORD,:DWORD,:DWORD,:DWORD	
   LogRefused      proto :DWORD,:DWORD,:DWORD,:DWORD
   GetFromIni      proto :DWORD,:DWORD,:DWORD,:DWORD
   PlayWav         proto :DWORD
   ReadMyFile      proto :DWORD    
   WriteLog        proto :DWORD,:DWORD
   WildMatch       proto :DWORD,:DWORD


; For reading console keyboard without using msvcrt
;_INPUT_RECORD STRUCT
;	 EventType   WORD ?
;	 WORD ? 		   ; For alignment
;	 UNION
;	     KeyEvent		   KEY_EVENT_RECORD	     <>
;	     MouseEvent		   MOUSE_EVENT_RECORD	     <>
;	     WindowBufferSizeEvent WINDOW_BUFFER_SIZE_RECORD <>
;	     MenuEvent		   MENU_EVENT_RECORD	     <>
;	     FocusEvent		   FOCUS_EVENT_RECORD	     <>
;	   ENDS
;_INPUT_RECORD ENDS

.data
align 4
   zero		  dd 0
   one		  dd 1	
;  val4096  	  dd 4096

   ActiveNodes	  dd 0			; Number of currently active nodes
   wsa2size 	  dd SIZEOF wsa2
   StopFlag 	  db 0			; Enable this Flag to stop accepting telnet sessions
   fMtStrinG	  db "%lu",0		; Format string mode used by wsprintf
   ClassName	  db 'ConsoleWindowClass',0
   Net2BBSTitle	  db "Net2BBS Telnet Server",0
   IniFileName	  db "net2bbs.ini",0
   HelpFileName     db "net2bbs.txt",0
   IniSectionName   db  "Settings", 0	    ; [Settings] is our .INI Section
   DateTxt          db  "00-00-0000 "	    ; Date Format for WriteLog
   TimeTxt          db  "00:00:00"		    ; Time Format for WriteLog
   
					          ; The following are log file messages:
   Node_            db  "Node ",0
   ConnectTxt       db  "Incoming connection: ",0
   ResolvedTxt      db  "Hostname: ",0
   UnknownTxt       db  "Unknown",0
   OpenedTxt        db  " opened.",0
   ClosedTxt        db  " closed.",0
   RefusedTxt       db  "Refused (",0
   Refused1Txt      db  "All Nodes in use).",0 
   Refused2Txt      db  "Semaphore exists).",0 
   Refused3Txt      db  "Matched kill list).",0

   logonwav         db  "logon.wav",0    ; Play this sound during a new logon (if it exists)
   logoffwav        db  "logoff.wav",0   ; Play this sound during a logoff (if it exists)
   BBSTitle         db  "BBS node "      ; The Title of an active BBS node window
   BBSTitleNode     db   "   ",0         ; Room to add the node number
   BUSYtxt          db  "BUSY"   ; Send this to client when all nodes are in use
   CRLF             db  10,13,0  ; Send this too
   CRLFLF   db 10,10,13,0
   spacestring      db  " ",0            ; string spacer
;  ANSIClear        db  01Bh,"[2J"       ; ANSI command to clear the remote screen
   HitEscAgainTxt   db  10,10,10,10,10,9,9,"Press ESC to exit, or any other key to resume "

   ntext	db  "*n",0 ; Command Line Macro to replace with Node value    (must be lower case here)
   htext	db  "*h",0 ; Command Line Macro to replace with Handle value  (must be lower case here)  
   IPtext	db  "*i",0 ; Command Line Macro to replace with IP Address    (must be lower case here)
   restext	db  "*r",0 ; Command Line Macro to replace with resolved name (must be lower case here)   

   csbi		CONSOLE_SCREEN_BUFFER_INFO <>


.data?
align 4
   TCPport     dd ?		; Default TCP port = 23   
   StartNode   dd ?		; First node to use
   MaxNodes    dd ?		; Maximum number of nodes
   LastNode    dd ?		; Last node number (startnode+maxnodes-1)
   INI_ADDR    dd ?		; Address of NET2BBS.INI
   hWnd        dd ?		; Handle of Console Window
;  hStdIn      dd ?		; Handle of Standard Input - not used
   hStdOut     dd ?		; Handle ot Standard Output - Needed for Color text 
   hInSock     dd ?		; Handle of Incoming Socket
   ;hProcess   dd ?		; Handle of Main Process
   hAcceptThread  dd ?		; Handle of Accept Thread
   ThreadID    dd ?		; Thread ID is not used currently (write only)
   hLogFile    dd ?		; Handle of the Log File
   written     dd ?		; Bytes written to log file - Not currently used (write only)
;  NodeLines   dd ?		; The number of lines to set the node window for (if non-zero)

   SysTime SYSTEMTIME  <?>	; Used by GetLocalTime
   sinfo   STARTUPINFO <?>	; Used for shell
   pinfo   PROCESS_INFORMATION <?> ; Used for shell

   wsd WSADATA      <?>		; Winsock data structure
   wsa sockaddr_in  <?>		; Winsock primary   sockaddress_inbound structure
   wsa2 sockaddr_in <?>		; Winsock secondary sockaddress_inbound structure

   NodeTable       db 256 dup (?) ; This table defines which nodes are in use(1) or inactive(0).
   LogBuf          db 128 dup (?) ; Buffer used for current log line
   CommandTxt      db 128 dup (?) ; Spawn Command line provided in INI
   StartPath       db 128 dup (?) ; Node Start Path provided in INI
   KillFileName    db  64 dup (?) ; List of blocked IP's (without a path)
   KillMsg         db 128 dup (?) ; Text to show a blocked IP
   KillMsgFileName db 128 dup (?) ; Kill Message FileName
   EditorName      db 256 dup (?) ; Editor Filename + space + path to Net2BBS\
   EditorCmd       db 256 dup (?) ; Editor Filename + space + path to Net2BBS\filename to open

   LogFileName     db 128 dup (?) ; Log FileName
   SemFileName     db 128 dup (?) ; Semaphore FileName
   ResolveMsg      db 128 dup (?) ; Message shown to user at connect (if Resolve enabled)
   TCPportTxt      db   8 dup (?) ; Ascii text of the TCP port (default 23)
   StartNodeTxt    db   4 dup (?) ; Ascii text of the first telnet node number
   MaxNodesTxt     db   4 dup (?) ; Ascii text of the maximum number of telnet connections
   NodeLinesTxt    db   4 dup (?) ; Ascii text of the number of lines in the node window (25 or 50)
   DebugModeTxt    db   2 dup (?) ; Ascii "0"=disable, "1"=enable - Display debug messages 
   ResolveModeTxt  db   2 dup (?) ; Ascii "0"=disable, "1"=enable - Resolve IP address to hostname 
   ShowHostTxt     db   6 dup (?) ; Ascii text of the ShowHost mode for showing caller their hostname
   NodeViewTxt     db   3 dup (?) ; Ascii text of the showWindow mode for node windows
   MainViewTxt     db   3 dup (?) ; Ascii text of the ShowWindow mode for this window
   NodeView        db          ?  ; Node ShowWindow view. Default = 1 (Normal)
   temp            dd          ?  ; Temporary dword used by FillConsoleOutputAttribute
   
;------------------------------------------------------------------------------------------------
.code

start:
	invoke StartServer
	invoke ExitProcess,0
	
;------------------------------------------------------------------------------------------------
; StartServer - Tell Winsock to Accept TCP connections, each in a new thread
  StartServer proc

	call   InitConsole						    ; Init Console mode and clear screen

; InitConsole returns with the number of columns (X) in the console screen
; Multply by 2 and draw a blue bar on top two rows.
 
      shl   ebx,1  ; Multiply column count by 2
  
	invoke FillConsoleOutputAttribute,hStdOut,31,ebx,NULL,ADDR temp    ; Create blue background color at top
	invoke SetTextColor,10,1 ;Green text on blue background
	print " Net2BBSķ " ; was -=Net2BBS=-
	invoke SetTextColor,15,1 ; white text on blue background
	print " Telnet Server 1.03" ; 1.03<Omega>
	invoke locate,6,0
	print "2"              ; make the "2" in Net2BBS white
	invoke SetTextColor,9,1 ; blue text on blue background
	invoke locate,73,0
      print " ",250,"pcm",250,10,10,13 ; sign it .pcm.
	call GetSettingsFromIni 	; Read the INI file and process it
	jnc iniok
	jmp error_exit			; exit if INI file not found
iniok:	
	invoke memfill, ADDR NodeTable, sizeof NodeTable, 0 ; Zero fill Node table

	cmp byte ptr DebugModeTxt,"0"
	je Main
	print "Debug: Command="
	invoke StdOut,ADDR CommandTxt
	invoke StdOut,ADDR CRLF		; print " ",10,13

Main:
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Main Telnet Section
; Here's how it works:
;
; Winsock Startup.
; "Socket" to get socket Descriptor.
; "htons" to convert TCP port from decimal to network bytes.
; "Bind" to own a TCP port.
; "Listen" for incoming connections on port.
; "CreateProcess" to handle each connection in its own thread.
;
; Once thats done, just wait for the ESC key to be pressed to exit.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	invoke SetTextColor,12,0			 ; In case of error, set Color=Red

	invoke WSAStartup,0202h,addr wsd		 ; Enable WinSock version 2
	.if eax!=NULL				 ; Check for error   
	     print "WinSock Error"
	jmp error_exit
	.endif

	invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP	; "Socket" sets us up the descriptor
	mov	hInSock, eax			    ; save socket descriptor handle


;************************ Experimental Socket Buffer Size adjustment ****************************
; Tested two methods of defining recvbuf and sendbuf sizes... no noticable improvments found
;
; ;;invoke setsockopt,hInSock,IPPROTO_TCP,SO_RCVBUF,offset val4096,SIZEOF val4096  ; set recvbuf	
; invoke setsockopt,hInSock,SOL_SOCKET,SO_RCVBUF,offset val4096,SIZEOF val4096	; set recvbuf	
;
;   .if eax!=NULL
;	print "Set Recv Size failed"
;	jmp error_exit
;   .endif
;
;  ;;invoke setsockopt,hInSock,IPPROTO_TCP,SO_SNDBUF,offset val4096,SIZEOF val4096  ; set sendbuf
;  invoke setsockopt,hInSock,SOL_SOCKET,SO_SNDBUF,offset val4096,SIZEOF val4096  ; set sendbuf
;	.if eax!=NULL
;     print "Set Send Size failed"
;   jmp error_exit
;    .endif
;************************************************************************************************


	mov wsa.sin_family, AF_INET 	    ; Set address family
;	mov wsa.sin_addr, INADDR_ANY	    ; use all network interfaces available
	invoke htons,TCPport		    ; Convert port values host/network bytes 
	mov wsa.sin_port, ax		    ; store sin_port to bind		

	invoke bind,hInSock,addr wsa,sizeof sockaddr_in   ; "Bind" to port socket
	.if eax!=NULL						  ; Check for error
	  print "Can't open TCP port ",7
	  invoke StdOut,ADDR TCPportTxt
	  jmp error_exit
	.endif

	invoke listen,hInSock,3			   ; "Listen" for incoming connection (maximum=3) SOMAXCONN
	.if eax!=NULL				   ; Check for error
	   print "Listen Error"
	   jmp error_exit
	.endif

	invoke CreateThread,0,0,offset AcceptThread,0,0,addr hAcceptThread ; Create a Thread to accept new users


; Now the Telnet Server is up and running in another thread, so just process keyboard commands.
 
readkey:
	getkey      	; get a key press
	or ecx,ecx		; is it an extended key code, (function key, arrow, etc)?
	jz standard_key	; skip this if its not.

extended_key:
	cmp al,59		; test for F1 key	
	je gotF1
	jne readkey		; ignore any other extended key

standard_key:
	cmp al,01Bh		; test for ESC
	je gotesc
	or al,020h		; force lower-case result
	cmp al,"e"		; test for "E" or "e"
	je gote
	cmp al,"c"		; test for "C" or "c"
	je gotc
	jne readkey		; loop if no matches


;-----
gotF1:
	; "F1" was pressed - Run editor and pass file name of the HelpFile

	mov ebx, offset HelpFileName	; F1 pressed, Open Helpfile net2bbs.txt
	jmp short RunEditor

;-----
gotc: 
	; "c" was pressed - Run editor and pass the name of the Configuration INI file 

;print "Restart after saving changes",10,13
mov ebx,offset IniFileName
jmp short RunEditor

;-----
gote:
	; "e" was pressed - Run editor and pass the name of the kill list

mov ebx,offset KillFileName
jmp short RunEditor

;------
gotesc:
	; "ESC" was pressed - Display a separate console buffer with a Red background to confirm exit

	invoke	SetTextColor,15,4   ; Create a new Console screen with White Text on Red Background
	invoke	CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,0,0,CONSOLE_TEXTMODE_BUFFER,0
	mov		ebx,eax 	    ; Save Handle of Screenbuffer in ebx
	invoke	WriteConsole,ebx,ADDR HitEscAgainTxt, sizeof HitEscAgainTxt, ADDR written, NULL ;Print to it
	invoke	SetConsoleActiveScreenBuffer, ebx ; Activate it
	invoke	SetTextColor,10,0 ; Bright Green  ; Restore color of future output
	getkey			; wait for another keypress
	push eax
	invoke CloseHandle,ebx	; close the red console buffer first (1.02 fix for Win 7)
	pop eax
	cmp al,01Bh		; ESC key?
	je cleanup		; If so, cleanup and exit
readkeyx:
    	jmp readkey
		; otherwise return to main wait


; ---------
; RunEditor runs the defined editor and passes it a filename to open.
; EBX = pointer to the filename string.

RunEditor:
	mov byte ptr EditorCmd, 0   
	invoke lstrcat, ADDR EditorCmd, ADDR EditorName    ; Copy the EditorName to the Editor Command line
	invoke lstrcat, ADDR EditorCmd, ebx  ; Add filename to edit to the "edit filename" Command Line

	invoke CreateProcess, NULL, ADDR EditorCmd, NULL, NULL, NULL,
			      CREATE_NEW_CONSOLE Or NORMAL_PRIORITY_CLASS,
			      NULL,NULL,addr sinfo,addr pinfo 

	jmp short readkeyx     ; resume processing keyboard input

error_exit:
	invoke SetTextColor,15,0	; Color= White
	print " ",10,13,"*** Press Enter to Exit ***"
jel:
	getkey
	cmp eax,13 ; Got Enter?
	jne jel    ; jello till we do

	;invoke locate,0,6	; Delete the "Press Enter"
	;print "                           "

cleanup:
	mov    StopFlag,1		; Tell AcceptThread its time to stop
	invoke Sleep,210		; Wait for AcceptThread to die
	invoke shutdown,hInSock,SD_BOTH ; shutdown socket
	invoke closesocket,hInSock	; Close socket
	invoke WSACleanup		; Cleanup Winsock
	invoke SetTextColor,15,0	; Set White text on black background
	ret				      ; Exit Net2BBS
StartServer endp


; 
; 
;------------------------------------------------------------------------------------------------
; AcceptThread - This is the thread which will accept incoming connections,
;		     and hands each one off to their own SpawnNode Thread 
;
  AcceptThread proc near param:dword

	invoke SetTextColor,7,0
	print	"Waiting for connections on port "
	invoke StdOut,ADDR TCPportTxt

	print ".",10,13,"Commands: [ESC] Exit, [C] Configure INI, [E] Edit Blocked IP List, [F1] Help"

	invoke SetTextColor,15,0 ; white text on blue background
	mov ebx,5                ; The Commands list is on line 5 if debugmode=1

	cmp byte ptr DebugModeTxt,"0"
	jne white_hotkeys
	dec ebx                   ; otherwise the Commands list is on line 3.
	dec ebx
      
white_hotkeys:
	invoke locate,11,ebx          ; Position cursor
	print "ESC"                   ; Whiten it
	invoke locate,23,ebx          ; Postion cursor
	print "C"                     ; Whiteen it
	invoke locate,42,ebx          ; Postion cursor
	print "E"                     ; Whiten it
	invoke locate,68,ebx          ; Postion cursor
	print "F1"                    ; Whiten it
	invoke StdOut,ADDR CRLFLF     ; print 10,10,13
	invoke	  SetTextColor,10,0

AT_loop:
	invoke accept,hInSock,ADDR wsa2, ADDR wsa2size  ; "Accept" a new incoming connection.
									; wsa2=buffer for incoming ip
	.if eax!=INVALID_SOCKET					; If socket is good, Create the Thread. 
	    invoke CreateThread,0,0,offset SpawnNodeThread,eax,0,addr ThreadID ; eax is the winsock handle
	.endif
	invoke Sleep,200	       ; sleep a while
	cmp StopFlag, 0	       ; is AcceptThread being told to stop ?
	je AT_loop		       ; if not, loop
	ret			       ; Exit
AcceptThread endp


;------------------------------------------------
;------------------------------------------------
;------------------------------------------------------------------------------------------------
; SpawnNodeThread - This thread is created for each connection. It spawns NetFoss and waits.

  SpawnNodeThread proc near hSock:dword

;----------------------------	
local hDupeSock:dword	    ; The Duplicate Socket Handle
local Node:dword  	    ; Node number for this thread
local pMem:dword  	    ; Allocated Memory Buffer Handle for Blocked List
local rpos:dword  	    ; Position in Blocked IP File
local pHostIPAddr:dword     ; pointer to the Host IP Address (non-dotted)
local pHostName:dword	    ; pointer to the resolved HostName
local myIPTextAddr:dword    ; This will contain address to myIPText!
local NodeTxt[6]:byte	    ; Node number in ascii
local HandleTxt[6]:byte     ; Handle number in ascii
local TempBuff1[128]:byte   ; Temp buffers to replace command line macros
local TempBuff2[128]:byte   ; 
;----------------------------

	mov eax,wsa2.sin_addr	; Save the Internet Host Address
	mov pHostIPAddr,eax
	invoke inet_ntoa,eax	; Convert Internet Host Addr to dotted IP addr
	mov myIPTextAddr,eax

	lea edi,LogBuf				    ; Set EDI pointer to start of buffer
	invoke lstrcpy,edi,ADDR ConnectTxt	    ; Copy "Incoming connection:" text to buffer
	add edi,sizeof ConnectTxt-1		    ; point EDI to end
;	invoke WriteLog, ADDR LogBuf, myIPTextAddr   ; Write it to log (and to screen)
; don't write it yet! (saves an extra line in the log file)

	xor eax,eax ; 1.01 bugfix		    ; Zero Node value for now	
	mov Node,eax

findnode:
	mov ebx, offset NodeTable	; Point EBX to nodetable, indexed with ECX
	mov ecx,StartNode
	dec  ecx
findnode1:
	cmp byte ptr [ebx+ecx],0	; Is node in use?
	je foundnode			; If not then claim it
	inc ecx 			; next
	cmp ecx,LastNode		; only check up to Last Node
	jne findnode1		; loop

; Here get out with Node=0, and handle no node refusal later on.

	xor ecx,ecx
	jmp short setnode

foundnode:
	inc byte ptr [ebx+ecx]		; Enable this node in the table
	inc ActiveNodes
	inc ecx
setnode:
	mov Node,ecx			; Convert Node number to ascii
	or ecx,ecx
	jz nonode2			; Get out if node=0
	invoke dw2a,ecx,ADDR NodeTxt	; and store in NodeTxt

; Write the Users Connection info to Log file

	invoke lstrcpy,edi,ADDR Node_	; Copy "Node " text to buffer
	add edi,sizeof Node_-1		; point EDI to end
	invoke lstrcpy,edi,ADDR NodeTxt ; Copy Node Number text to buffer
	invoke lstrlen,ADDR NodeTxt	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi,ADDR OpenedTxt	; Copy " opened." text to buffer
	add edi,sizeof OpenedTxt-1	; point EDI to end

nonode2:
	invoke WriteLog, ADDR LogBuf, myIPTextAddr	; Write it to log (and to screen)

	cmp byte ptr ResolveModeTxt,"0"	    ; Check if ResolveIP mode enabled
	je check_blockfile				    ; Get out if not

	cmp Node,0			    ; Get out if no node
	je ResolveIP

	invoke lstrcat, ADDR ResolveMsg, ADDR spacestring   ; Add a space to the resolve message 
	mov eax,len(ADDR ResolveMsg)               ; Get size of the ResolveMsg
	invoke send,hSock,ADDR ResolveMsg,eax,0    ; Write the ResolveMsg text to the socket


;--------------------------------------
; Resolve the IP address to a hostname
;--------------------------------------
;
ResolveIP:

	invoke gethostbyaddr,ADDR pHostIPAddr,4,AF_INET ; resolve HostIP Value into hostname
	mov ebx, offset UnknownTxt			; Assume IP won't resolve
	mov pHostName, ebx ; offset UnknownTxt	    ; Set default hostname text in case resolve fails
	test eax,eax
	jz resolvefailed
	mov ebx,[eax].hostent.h_name			; Resolve was sucessful!   
resolvefailed:
	invoke lstrcpy,edi,ADDR ResolvedTxt	    ; Copy "Hostname: " text to buffer
	add edi,sizeof ResolvedTxt-1		    ; point EDI to end
	invoke lstrcpy,edi,ebx			    ; Copy Hostname text to buffer
	add edi,len(ebx) ;(pHostName)		    ; point EDI to end
	mov pHostName,ebx
showresolve:
	invoke WriteLog, ADDR LogBuf, myIPTextAddr   ; Write it to log (and to screen)

;Display the result to the user, along with a CR/LF!!!

	cmp Node,0
	je check_blockfile

;	invoke atodw,addr ShowHostTxt
;	push eax
	mov ebx,pHostName
;	or eax,eax
;	jz skipresult
	;invoke send,hSock, ebx, len(ebx),0 ; this didn't work due to a macro issue
	invoke send,hSock, pHostName, len(ebx),0        ; Send resolved name to client

skipresult:
	invoke send,hSock, offset CRLF, sizeof CRLF-1,0 ; Send Carrage Return + Line Feed
;	pop eax
;	invoke Sleep,eax

;---------------
check_blockfile:

; Check if the users IP or hostname exists within our file list of blocked IP's
; Open and read the KillFile

	invoke ReadMyFile, ADDR KillFileName
	jc noblockfile	    ; get out if the file was not found
	mov pMem,esi	    ; save the file pointer in pMem

	xor eax,eax	    ; start at the first line (position 0)
	mov rpos,eax
	jmp short linein
	
readloop:
	xor eax,eax	    ; check if rpos=0, if so we are done
	cmp rpos,eax
	je blockdone
linein:
	mov rpos, linein$(pMem,ADDR TempBuff1,rpos) ; This macro reads a line, and updates position

; Before we run the WildMatch, we should remove any spaces from the end of line
; (another idea: could remove spaces from entire line)

	invoke lstrlen,ADDR TempBuff1	    ; Get Length of string
	test eax,eax			    ; zero?
	jz readloop			    ; skip empty line
	mov ebx,eax
kill_trailing:
	cmp byte ptr TempBuff1[ebx], " "    ; look for a space
	jne notspace
	dec ebx 			    ; loop till all checked
	jnz kill_trailing
	jz readloop ; if the line is empty, skip the wildmatch on this line

notspace:
	mov byte ptr TempBuff1+1[ebx],0     ; define the end-of-line with a zero
;	 invoke StdOut,ADDR TempBuff1
;	 print "killed spaces",10,13


; Future Idea: could check if first character is either a plus or minus
; + = always allow this ip (takes priority).
; - = deny this ip (assumed)
; if an IP was explecitly allowed using +, then always allow it even if there is a deny *.
; 
; so when a + is found that matches, end the search
; when a deny is found that matches, set the result as fail, and continue searching.
; at the end of search, check result


	invoke WildMatch, ADDR TempBuff1, myIPTextAddr	; Compare Line with dotted IP text
	;test al,al					; got a match?
	jnz gotwild
	cmp byte ptr ResolveModeTxt,"0"			; Check if resolving hostnames
	je readloop					; get out if not

	xor eax,eax					; check if hostname is defined					   
	cmp pHostName,eax
	je readloop					; get out if not

	invoke WildMatch, ADDR TempBuff1, pHostName	; Compare Line with HostName
	;test al,al					; got a match?
	jz readloop	  

gotwild:
; Here we found a match, so send the killmsg (or killfile) and disconnect the user

	invoke ReadMyFile, offset KillMsgFileName	; attempt to read killmsg file		  
	jc nokillmsgfile				; skip if it doesnt exist
	invoke send,hSock,esi,ecx,0			; Write the KillMsg file to the socket
	invoke GlobalFree,esi				; free the killmsg file allocated memory
	jmp short killfinish

nokillmsgfile:
	invoke send,hSock,ADDR KillMsg,sizeof KillMsg,0	  ; Write the unwelcome text to the socket
killfinish:
	invoke LogRefused,ADDR LogBuf, ADDR Refused3Txt,sizeof Refused3Txt-1, myIPTextAddr ; Note the Log
	invoke GlobalFree,pMem 	; free the allocated memory
sleepclose:
      invoke Sleep,1000       ; wait a second
	jmp freenode ; was close			; and close connection

blockdone:
	invoke GlobalFree,pMem		; free the allocated memory

noblockfile:


; If there is a semaphore file, send it to winsock and refuse user.

	cmp byte ptr SemFileName,0	; Is Semaphore file defined?
	je  nosemfound			; skip if none

	invoke	ReadMyFile, offset SemFileName	; Read the entire semaphore file		 
	jc nosemfound						; Skip if it's not there
	invoke	send,hSock,esi,ecx,0			; Write the semaphore file to the socket
	invoke	GlobalFree,esi				; free the allocated memory
	invoke	LogRefused,ADDR LogBuf, ADDR Refused2Txt,sizeof Refused2Txt-1, myIPTextAddr ; Note Sem Refusal in Log
	jmp sleepclose						; close connection

nosemfound:

; check if all nodes are busy (and handle the no nodes available state)

	xor eax,eax
	cmp Node,eax
	jne nodevalid	; Node 0 must fail, with a busy message

	invoke LogRefused, ADDR LogBuf, ADDR Refused1Txt,sizeof Refused1Txt-1, myIPTextAddr ; All nodes are in use

	;cmp byte ptr ResolveModeTxt,"0"		    ; Check if ResolveIP mode enabled
	;je tellbusy						    ; Skip Clear if not
	;invoke send,hSock,ADDR ANSIClear,SIZEOF ANSIClear,0     ; Send an ANSI clear screen command

tellbusy:
	invoke send,hSock,addr BUSYtxt,sizeof BUSYtxt+2,0    ; Tell user BUSY
	jmp sleepclose			; Close connection


nodevalid:

; Here we have a valid node number, and the IP / Hostname were not in the block/kill list, so all is good.
; allow user to spawn using a duplicate socket handle!


	invoke	  GetCurrentProcess	; Get hProcess number
	mov ebx,eax

	; Duplicate the Socket Handle for the spawned process

	invoke DuplicateHandle,ebx,hSock,ebx,addr hDupeSock,0,TRUE,DUPLICATE_SAME_ACCESS  ; Store the dupesockhandle value in ascii
	invoke dw2a,hDupeSock, ADDR HandleTxt      ; Create HandleTxt ascii


; Now NodeTxt and HandleTxt are defined, so replace *N/*H/*I/*R macros on the Command Line

 invoke Replace,ADDR CommandTxt,ADDR TempBuff1,ADDR ntext, ADDR NodeTxt   ; Replace *N with {node}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR htext, ADDR HandleTxt ; Replace *H with {handle}
 invoke Replace,ADDR TempBuff2, ADDR TempBuff1,ADDR IPtext, myIPTextAddr  ; Replace *I with {IP Address}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR restext, pHostName    ; Replace *R with {Resolved text}


; Now Command is in TempBuff2
; Do the same with the StartPath (place in TempBuff1)

 invoke Replace,ADDR StartPath, ADDR TempBuff1,ADDR ntext,ADDR NodeTxt	 ; Replace *N with {node}

; Now spawn NetFoss to take over the connection

	invoke PlayWav,addr logonwav			    ; Play the logon wav
	invoke lstrcpy,ADDR BBSTitleNode,ADDR NodeTxt ; Create Title (with node number)
	;cmp byte ptr ResolveModeTxt,"0"		    ; Check if ResolveIP mode enabled
	;je doshell						    ; Skip Clear if not
	;invoke send,hSock,ADDR ANSIClear,SIZEOF ANSIClear,0     ; Send an ANSI clear screen command
doshell:
	invoke Shell, ADDR TempBuff1, ADDR TempBuff2  ; Shell to NF+BBS, passing Path + Command to Spawn
	invoke CloseHandle,hDupeSock			    ; On return, Close Dupe Handle
freenode:
	mov ebx, offset NodeTable
	mov ecx,Node
	dec ecx
	jc close   ; skip over node removeal if node was zero
	dec byte ptr [ebx+ecx]			; Mark node as available in Node Table
	dec ActiveNodes
	invoke PlayWav,addr logoffwav		; Play the logoff WAV
close:
	invoke shutdown,hSock,1 		; force disconnect
	invoke closesocket,hSock  		; Close Orig Socket
						      ; Process done
	cmp Node,0
	je  nonode
	lea edi,LogBuf			      ; Set EDI pointer to start of buffer
	invoke lstrcpy,edi,ADDR Node_	      ; Add "Node 1 closed." line to log
	add edi,sizeof Node_-1		    
	invoke lstrcpy,edi,ADDR NodeTxt     ; copy Node number text
	invoke lstrlen, ADDR NodeTxt	      ; point EDI to end
	add edi,eax
	invoke lstrcpy,edi,ADDR ClosedTxt	; Copy "closed." text to buffer
	add edi,sizeof ClosedTxt-1 	      ; point EDI to end 
	invoke WriteLog, ADDR LogBuf, myIPTextAddr	; Write it to the log (and to the screen)
nonode:
	ret

SpawnNodeThread endp

;------------------------------------------------------------------------------------------------
ReadMyFile proc near lpfilename

; This opens a file (if the file already exists), and reads the entire file into memory.
; Exit with Carry Set to indicate an error
; Exit with ESI= Global Memory handle (to be released) if sucessful
; AND ECX= bytes read

local hTempFile
local bytesread

	invoke GetFileAttributes, lpfilename		   ; Check if the file exists
	inc eax
	jz readmyfile_error

	invoke CreateFile,lpfilename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
	mov hTempFile,eax
	invoke GetFileSize,hTempFile,NULL	; get the file size
	mov ebx, eax				; ebx=file size
	invoke GlobalAlloc,GMEM_FIXED,ebx	;  allocate at least that much memory
	mov esi, eax				;  Save the memory Handle.
	invoke	ReadFile,hTempFile,	;  Read the Semaphore File
			esi,				;  Buffer Address
			ebx,				;  Max Amount to send
			ADDR bytesread, 		;  In: bytes actually read
			NULL				;  overlapped

; Here we should make sure the entire file was read, and try to read the remainder if needed.
; Perhaps we should exit this proce with carry set if there was an error?
		
	invoke CloseHandle, hTempFile		   ; close the file handle
	mov ecx, bytesread			   ; Return bytes read in ECX
	clc
	ret

readmyfile_error:
;print "file not found",10,13
	stc
	ret

ReadMyFile endp

;------------------------------------------------------------------------------------------------
PlayWav proc near lpfilename
; 
; Check if a WAV file exits, and if it does, play it

	invoke GetFileAttributes, lpfilename
	inc eax		; Check that EAX!=-1
	jz NoPlay
	Invoke PlaySound, lpfilename, NULL, SND_FILENAME or SND_ASYNC
NoPlay:
	ret
PlayWav endp

;------------------------------------------------------------------------------------------------
WriteLog proc near lplogbuffer, lpIPTextAddr

; This writes the string passed to it to the log file (and screen), appending the current
; date and time to the beginning, and appends a CR/LF to the end.


local buff1[128]:byte	     ; Temp buffer to write log in

; First append CR/LF and zero to end of custom string:

mov dword ptr [edi],00000A0Dh		; force it as a dword

; Get the Date and Time, and format it.

	invoke GetLocalTime,addr SysTime
	invoke GetTimeFormat,NULL,NULL,addr SysTime,SADD("HH':'mm':'ss "),addr TimeTxt,sizeof TimeTxt
	invoke GetDateFormat,NULL,NULL,addr SysTime,SADD("MM'-'dd'-'yyyy"),addr DateTxt,sizeof DateTxt
	mov byte ptr DateTxt+10," " ; put a space between date and time. 
	lea esi, buff1		    ; Point EDI to buffer
	invoke lstrcpy,esi,Addr DateTxt	; Add Date+Time
	add esi,(sizeof DateTxt) + (sizeof TimeTxt)
	mov ebx,00202D20h		; " - ",0 
	mov [esi],ebx	    		        ; add it as a dword
	add esi,3
	invoke lstrcpy,esi,lpIPTextAddr	  ; Append the IP Address to buffer
	invoke lstrlen,lpIPTextAddr		  ; adjust buffer size for IP length
	add esi,eax
	;mov ebx, 00202D20h 
	mov [esi],ebx				  ; add " - " as a dword
	add esi,3
	invoke lstrcpy,esi, lplogbuffer	  ; Copy Custom String in Buff2 to Buff1
	lea esi, buff1

	invoke lstrlen,esi			  ; adjust buffer size for IP
	mov ebx,eax ; Store IP Length in ebx

; Write the entire line to the log

	invoke CreateFile,ADDR LogFileName,GENERIC_WRITE,FILE_SHARE_READ,0,
			  OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hLogFile,eax
	invoke SetFilePointer,hLogFile,0,0,FILE_END ; Point to end of log file
	invoke WriteFile,hLogFile,ADDR buff1,ebx,ADDR written,0
	invoke CloseHandle,hLogFile
	invoke StdOut,ADDR buff1		  ; Print it to screen as well
	mov edi,lplogbuffer			  ; Reset EDI pointer to start of buffer
	ret
WriteLog endp
;------------------------------------------------------------------------------------------------

LogRefused proc near lplogbuffer:DWORD, lpfilename:DWORD, lpfilesize:DWORD, lpIPTextAddr:DWORD 

	invoke lstrcpy,edi,ADDR RefusedTxt	; Add RefusedTxt to buffer
	add edi,sizeof RefusedTxt-1		; Adjust buffer end pointer 
	invoke lstrcpy,edi,lpfilename		; Add filename to buffer
	add edi,lpfilesize			; Adjust buffer end pointer
	invoke WriteLog, lplogbuffer, lpIPTextAddr	; Write the log entry
	ret
LogRefused endp


;----------------------------------------------------------------------------------------------- 
  Shell proc near lppath:DWORD,lpfilename:DWORD

; Shell - Spawn a process and wait for it to finish
; 
;
; LPCTSTR lpApplicationName,		       null
; LPTSTR lpCommandLine, 		       lpfilename
; LPSECURITY_ATTRIBUTES lpProcessAttributes,   null
; LPSECURITY_ATTRIBUTES lpThreadAttributes,    null 
; BOOL bInheritHandles, 		       true
; DWORD dwCreationFlags,		       create_new_cons+normal_prior (30h)
; LPVOID lpEnvironment, 		       null
; LPCTSTR lpCurrentDirectory,		       lppath
; LPSTARTUPINFO lpStartupInfo,		       addr sinfo
; LPPROCESS_INFORMATION lpProcessInformation   addr pinfo

	cmp byte ptr DebugModeTxt,"0"
	je skip2
	invoke SetTextColor,2,0	   ; Text = Dark Green
	print " Spawn: "
	invoke StdOut,lpfilename
	invoke StdOut,ADDR CRLF ; print " ",10,13
skip2:

	invoke memfill, ADDR sinfo, sizeof sinfo, 0
;	invoke GetStartupInfo,addr sinfo
	mov sinfo.cb,sizeof sinfo
	mov sinfo.lpTitle, offset BBSTitle		; Set the Window Title
;	mov sinfo.dwFlags, STARTF_USESHOWWINDOW	; Demand setting window view mode.
	mov ebx, STARTF_USESHOWWINDOW			; Demand setting window view mode.

	invoke atodw,addr NodeLinesTxt		; Get NodeLines= value
	or eax,eax
	jz skipsize

	or ebx, STARTF_USECOUNTCHARS Or STARTF_USESIZE ;or STARTF_USEPOSITION

; This sets the console buffer size (buffer size can be bigger then screen size, but must not be smaller!)
	mov sinfo.dwXCountChars,80
	mov sinfo.dwYCountChars,eax
    
; The console screen size can only be set in Pixels, so we must assume the default font size of 8x12 for this to work:
	mov sinfo.dwXSize, 80*8 ; multiply X size by font width, and always use X-size=80
	mov edx,12              ; multiply Y size by font height 
	mul edx  
	mov sinfo.dwYSize, eax

skipsize:

	mov sinfo.dwFlags, ebx	; Set the STARTF flags.

  ; ShowWindow modes:
  ; These are described here:  http://msdn.microsoft.com/en-us/library/ms633548.aspx
  ;
  ; SW_HIDE = 0
  ; SW_NORMAL = 1
  ; SW_SHOWMINIMIZED = 2
  ; SW_MAXIMIZE = 3
  ; SW_SHOWNOACTIVATE = 4
  ; SW_SHOW = 5
  ; SW_MINIMIZE = 6
  ; SW_SHOWMINNOACTIVE = 7
  ; SW_SHOWNA = 8
  ; SW_RESTORE = 9
  ; SW_SHOWDEFAULT = 10
  ; SW_FORCEMINIMIZE = 11
 
	movzx ax,NodeView 	; Window Show mode: Normal, Minimize, Maximize, Hidden, etc.

; Full Screen View option was disabled in version 1.03a
; because this function was only supported in XP and 2003.
;
; cmp al,99 ;99=Full-Screen
; jne set_node_view
;=======================================================
; Force Full-Screen window by stuffing keyboard events
; Sends Alt-Enter to console for Win XP, 2000, and 2003
; This will not work under Windows Vista or later!
;  invoke keybd_event,VK_MENU,38h,0,0
;  invoke keybd_event,VK_RETURN,1Ch,0,0
;  invoke keybd_event,VK_RETURN,1Ch,KEYEVENTF_KEYUP,0
;  invoke keybd_event,VK_MENU,38h,KEYEVENTF_KEYUP,0
;  mov ax,SW_NORMAL
;=======================================================

set_node_view:
	mov sinfo.wShowWindow, ax

	invoke CreateProcess, NULL, lpfilename, NULL, NULL, TRUE,
			CREATE_NEW_CONSOLE Or NORMAL_PRIORITY_CLASS,
			NULL, lppath, addr sinfo, addr pinfo

    .if eax 
	  invoke GetCurrentProcess ; Get Process of Net2BBS.exe
	  push eax
	  invoke SetPriorityClass,eax,IDLE_PRIORITY_CLASS	    ; lower net2bbs cpu use while waiting							     
	  invoke WaitForSingleObject, pinfo.hProcess, INFINITE    ; wait for process to terminate						      
	  pop eax
	  invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS 
	  invoke CloseHandle, pinfo.hThread			    ; Close open handles
	  invoke CloseHandle, pinfo.hProcess	   
    .else
	  cmp byte ptr DebugModeTxt,"0"
	  je Shell_end
	  print " Spawn: Failed!",13,10
    .endif 

Shell_end:
	invoke SetTextColor,10,0	    ; Text = Bright Green
	ret 
Shell endp


;------------------------------------------------------------------------------------------------
; Get Settings from net2bbs.ini

GetSettingsFromIni proc near ; uses ebx esi edi

    LOCAL   APP_Path[128] :BYTE
    LOCAL   INI_Path[128] :BYTE

    CTEXT MACRO text:VARARG
      LOCAL TxtName
      .data
	TxtName BYTE text, 0
      .code
      EXITM <ADDR TxtName>
    ENDM
    
	invoke  GetAppPath, ADDR APP_Path			; Get path of Application  
	invoke  GetAppPath, ADDR INI_Path			; Get path of Application for INI
	invoke lstrcat, ADDR INI_Path, ADDR IniFileName	; Append the Ini FileName to the INI path 	   

	; Make sure ini file can be found, or else we fail.

	invoke GetFileAttributes, addr INI_Path ; Does the .ini file exist?
	inc eax				; -1 means it doesn't exist
	jnz iniread
	invoke SetTextColor,12,0	; color=Red
	print  "Config missing: "
	invoke SetTextColor,7,0		; color=White
	invoke StdOut,ADDR INI_Path
	invoke StdOut,ADDR CRLF ; print " ",10,13
	stc 				; set carry to indicate error and exit
	ret
		
iniread:
	lea eax,INI_Path
	mov INI_ADDR, eax


; GetFromIni uses:  Command Text, default value, Where to place it, maximum size in bytes

 invoke GetFromIni, CTEXT("Command"),   ADDR zero,    ADDR CommandTxt, sizeof CommandTxt
 invoke GetFromIni, CTEXT("StartPath"), CTEXT("./"),  ADDR StartPath, sizeof StartPath
 invoke GetFromIni, CTEXT("Port"),      CTEXT("23"),  ADDR TCPportTxt,sizeof TCPportTxt
 invoke GetFromIni, CTEXT("Nodes"),     CTEXT("256"), ADDR MaxNodesTxt, sizeof MaxNodesTxt
 invoke GetFromIni, CTEXT("StartNode"), CTEXT("1"),   ADDR StartNodeTxt, sizeof StartNodeTxt
 invoke GetFromIni, CTEXT("Debug"),     CTEXT("1"),   ADDR DebugModeTxt, sizeof DebugModeTxt
 invoke GetFromIni, CTEXT("Resolve"),   CTEXT("1"),   ADDR ResolveModeTxt, sizeof ResolveModeTxt
 invoke GetFromIni, CTEXT("Log"),       CTEXT("telnet.log"), ADDR LogFileName, sizeof LogFileName
 invoke GetFromIni, CTEXT("Editor"),    CTEXT("notepad"), ADDR EditorName, sizeof EditorName
 invoke GetFromIni, CTEXT("KillList"),  CTEXT("kill.txt"), ADDR KillFileName, sizeof KillFileName
 invoke GetFromIni, CTEXT("KillMsg"),   CTEXT("Access Denied."), ADDR KillMsg, sizeof KillMsg
 invoke GetFromIni, CTEXT("KillMsgFile"), ADDR zero,  ADDR KillMsgFileName, sizeof KillMsgFileName
 invoke GetFromIni, CTEXT("Semaphore"),   ADDR zero,  ADDR SemFileName, sizeof SemFileName
 invoke GetFromIni, CTEXT("ResolveMsg"),  ADDR zero,  ADDR ResolveMsg, sizeof ResolveMsg
 invoke GetFromIni, CTEXT("ShowHost"),  CTEXT("1"),   ADDR ShowHostTxt, sizeof ShowHostTxt
 invoke GetFromIni, CTEXT("NodeView"),  CTEXT("1"),   ADDR NodeViewTxt, sizeof NodeViewTxt
 invoke GetFromIni, CTEXT("MainView"),  CTEXT("1"),   ADDR MainViewTxt, sizeof MainViewTxt
 invoke GetFromIni, CTEXT("NodeLines"), CTEXT("0"),   ADDR NodeLinesTxt, sizeof NodeLinesTxt

;invoke lstrcat, ADDR KillMsg, ADDR CRLF ; Add CR/LF to end of killmsg?

	invoke lstrcat, ADDR EditorName, ADDR spacestring   ; Add a space to the base EditorName 
	invoke lstrcat, ADDR EditorName, ADDR APP_Path      ; Add the Application path to the EditorName

	invoke atodw,addr NodeViewTxt	; Save the NodeView= value
	mov NodeView,al

	invoke atodw,addr MainViewTxt	; Get MainView= value
	invoke ShowWindow,hWnd,eax   ; Set our Console Window view

; this is now done later
;	invoke atodw,addr NodeLinesTxt	; Get NodeLines= value
;	mov NodeLines,eax
	
	invoke atodw,addr TCPportTxt	; Save the provided TCP port if its non-zero
;	or eax,eax
;	jnz setport
;	mov eax,23			; otherwise default to TCP port 23
;setport:
	mov TCPport,eax

	invoke atodw,addr StartNodeTxt	 ; Save the start node if its non-zero
	or eax,eax
	jnz setstartnode
	inc eax
setstartnode:
	mov StartNode,eax

	invoke atodw,addr MaxNodesTxt	; Save the max nodes if its non-zero
;	or eax,eax
;	jnz setmaxnode
;	mov ax,256
setmaxnode:
	mov MaxNodes,eax
	add eax,StartNode
	dec eax
	mov LastNode,eax		; Define LastNode (StartNode+MaxNodes-1)
    
    	cmp byte ptr DebugModeTxt,"0"
	je initdone
	invoke SetTextColor,2,0
	print "Debug: Read "
	invoke StdOut,ADDR INI_Path
	invoke StdOut,ADDR CRLF ; print " ",10,13

initdone:
	clc
	ret
GetSettingsFromIni endp

;------------------------------------------------------------------------------------------------
; Get a command from INI file

GetFromIni proc near lpCmd:DWORD, lpDefault:DWORD, lpDest:DWORD, DestSize:DWORD

; This stub calls GetPrivateProfileString in Kernel32.dll

 invoke	GetPrivateProfileString, ADDR IniSectionName, lpCmd, lpDefault, lpDest, DestSize, INI_ADDR
 ret
GetFromIni endp


;------------------------------------------------------------------------------------------------
; Get the Application Path

GetAppPath proc near lpPathBuffer:DWORD

	invoke GetModuleFileName,0,lpPathBuffer,128  ; return length in eax
	add eax, lpPathBuffer         ; Search from end to start
findslash:
	dec eax                        
	cmp BYTE PTR [eax],"\"  	; find the last "\"
	jne  findslash
	mov  BYTE PTR [eax+1],0		; write zero terminator after "\"
	mov  eax, lpPathBuffer
	ret
GetAppPath endp

;------------------------------------------------------------------------------------------------
; Initialize Console
;
; Returns with: EBX = X-console width
;               ECX = Y-console height (currently disabled)
InitConsole proc near

	Invoke SetConsoleTitle, ADDR Net2BBSTitle
	invoke FindWindow,ADDR ClassName, Addr Net2BBSTitle    ; Find Window handle matching this class/title
	mov     hWnd,eax 

;invoke CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,0,0,CONSOLE_TEXTMODE_BUFFER,0

; There is no need to change the input
;	invoke GetStdHandle,STD_INPUT_HANDLE
;	mov hStdIn, eax
;	invoke SetConsoleMode, hStdIn, ENABLE_PROCESSED_INPUT
;
; But we must define the output
	invoke GetStdHandle,STD_OUTPUT_HANDLE
	mov   hStdOut,eax

	cls		  ; Clear the screen
 ;	invoke FillConsoleOutputAttribute,hStdOut,00,80*25,NULL,ADDR temp   ; Force the screen to clear black

      invoke GetConsoleScreenBufferInfo,hStdOut,ADDR csbi
      movzx ebx,csbi.dwSize.x
 ;    mov   console_X_size,ebx
 ;    movzx ecx,csbi.swSize.y
 ;    mov   console_Y_size,ecx

      ret
      
InitConsole endp

;------------------------------------------------------------------------------------------------
; Convert Double-Word to ASCII string
;
; dwValue is passed as a value, direct, indirect or in register
; lpBuffer is the ADDRESS of the receiving buffer
; Returns with eax= number of characters written to buffer (zero=error).
;
; EXAMPLE:
; invoke dw2a,edx,ADDR buffer


dw2a proc near dwValue:DWORD, lpBuffer:DWORD

	invoke wsprintfA,lpBuffer,ADDR fMtStrinG,dwValue
      ;or eax,eax    ; Check if any bytes were written to the buffer (eax=0 means error!)
	ret
dw2a endp



;------------------------------------------------------------------------------------------------
; The procedures below this line were found in public forums and may or may not be public domain!
;------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------------------------
SetTextColor proc near fore:DWORD,back:DWORD

; 
; This proc sets the foreground and background attributes for
; the characters written to the console screen buffer.
;
; The color values are normal 4-bit IRGB character mode
; attributes where:
;   bit3 = intensity
;   bit2 = red
;   bit1 = green
;   bit0 = blue
; 
; The attribute is stored in a single byte.
	mov   eax,back
	shl   eax,4
	or	  eax,fore
	invoke SetConsoleTextAttribute,hStdOut,eax
	ret
SetTextColor endp


;------------------------------------------------------------------------------------------------
; Replace - Text String Search and Replace Function
;
;align 4

Replace proc near src:DWORD,dst:DWORD,txt1:DWORD,txt2:DWORD

;  Source String, Dest String, orig text, new text
    LOCAL lsrc	:DWORD

;	push ebx
;	push esi
;	push edi

	mov lsrc, len(src)	; procedure call for src length
	sub lsrc, len(txt1) 	; procedure call for 1st text length

	mov esi, src
	add lsrc, esi		; set exit condition
	mov ebx, txt1
	inc lsrc			; adjust to get last character
	mov edi, dst
	xor eax, eax		; zero EAX
	dec esi
	jmp rpst
; ----------------------------
;  align 4
pre:
    add esi, ecx		; ecx = len of txt1, add it to ESI for next read
;  align 4
rpst:
	inc esi
	cmp lsrc, esi		; test for exit condition
	jle rpout
	mov al, [esi]		; load byte from source
	mov ah,al
	or ah,020h
	cmp ah, [ebx]		; test it agqainst 1st character in txt1
	je test_match
	mov [edi], al		; write byte to destination
	inc edi
	jmp rpst
; ----------------------------
;  align 4
	test_match:
	mov ecx, -1 		; clear ECX to use as index
	mov edx, ebx		; load txt1 address into EDX
@@:
	inc ecx
	mov al, [edx]
	test al, al 		; if you have got to the zero
	jz change_text		; replace the text in the destination
	inc edx
;    cmp [esi+ecx], al		 ; keep testing character matches
	mov ah, [esi+ecx]
	or ah,020h
	cmp ah,al
	je @B
	mov al, [esi]		; if text does not match
	mov [edi], al		; write byte at ESI to destination
	inc edi
	jmp rpst
; ----------------------------
;  align 4
change_text:			; write txt2 to location of txt1 in destination
	mov edx, txt2
	dec ecx
@@:
	mov al, [edx]
	test al, al
	jz pre
	inc edx
	mov [edi], al
	inc edi
	jmp @B
; ----------------------------
;  align 4
rpout:				; write any last bytes and terminator
	mov ecx, -1
@@:
	inc ecx
	mov al, [esi+ecx]
	mov [edi+ecx], al
	test al, al
	jnz @B
;	pop edi
;	pop esi
;	pop ebx
	ret
Replace endp

;------------------------------------------------------------------------------------------------
; WildMatch - Checks if one string exists within another string, supporting wildcards "?" and "*".

WildMatch proc near wild :DWORD, string :DWORD ;uses ebx esi edi

    mov        ecx, wild
    mov        edx, string

    .while BYTE PTR [edx] != 0 && BYTE PTR [ecx] != "*"
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl != bh && bl != "?"
	    xor        eax, eax
	    ret
	.endif
	inc	   ecx
	inc	   edx
    .endw

    .while BYTE PTR [edx] != 0
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl == "*"
	    inc        ecx
	    mov        bl, [ecx]
	    .if bl == 0
		xor	   eax, eax
		inc	   eax
		ret
	    .endif
	    mov        esi, ecx
	    mov        eax, edx
	    inc        eax
	.elseif bl == bh || bl == "?"
	    inc        ecx
	    inc        edx
	.else
	    mov        ecx, esi
	    mov        edx, eax
	    inc        eax
	.endif
    .endw
    
    .while    BYTE PTR [ecx] == "*"
	inc	   ecx
    .endw
    
	movzx eax,byte ptr [ecx]
	or eax,eax ; is it zero?
	sete al    ; set ZF to 1 if zero, or to 0 if non-zero.
	test eax,eax
	ret
WildMatch endp

end start
